#!/usr/bin/perl
#
# This code is distributed under the terms of the GPL
#
# (c) Tiago Freitas Leal
#
###2006-0422 - uninstall.pl from QoS v1.8 by NetWhiz modded by catastrophe for use with enhancedipblock v.0.2
# - Included v2.1 easymod routine from DHCP Pack by Tiago
###2007-0107 - modded by catastrophe for use with NoWireAP v.0.2.0


require '/var/smoothwall/mods/nowireap/modlib.pl';

# # # # # # # # # # # # # # # # # # #
# check for existing installations  #
# # # # # # # # # # # # # # # # # # #

print "\nUninstalling NoWireAP v.0.2, please wait...\n\n";

#if (&installed ("/var/smoothwall/langs/base.pl", "# nowireap v.0.2")) {
#	print "\nPlease remove # NoWireAP v.0.2\n";
#	print "Note - Run uninstall-020.pl script.\n \n";
#	exit;
#}

#if (-e "/var/smoothwall/mods/NoWireAP/installed") {
#	if (&installed ("/var/smoothwall/mods/NoWireAP/installed", "# nowireap v.0.2")) {
#		print "\nPlease remove # NoWireAP v.0.2\n";
#		print "Note - Run uninstall-020.pl script.\n \n";
#		exit;
#	}
#}


# # # # # # # # # # # #
# handle file copying #
# # # # # # # # # # # #

#	$storebkp =	where to store backup of the files that are changed by your mod
#	$moddir =	where your mod files are
#	$wkdir =	where you are changing files (backup from and copy to)
#
#	backupinstall ($file, $wkdir, $storebkp, $moddir);
#	backup ($file, $wkdir, $storebkp);
#	install ($file, $wkdir, $moddir);
#	uninstallrestore ($file, $wkdir, $storebkp);
#	uninstall ($file , $wkdir);
#
#	installed ($file, $string);
#
#	search for $string into $file => 1 found / 0 not found

my $bkp = '/var/smoothwall/mods/nowireap/backup';

$wkdir = '/etc/rc.d';
&uninstall ('rc.wireless.update', $wkdir);

$wkdir = '/home/httpd/cgi-bin';
&uninstall ('nowireap.cgi', $wkdir);

$wkdir = '/home/httpd/html/help';
&uninstall ('nowireap.cgi.html.en', $wkdir);


# # # # # # # # # # # #
# handle file editing #
# # # # # # # # # # # #

my $param = '/var/smoothwall/mods/nowireap/params';

&easymod ("/home/httpd/cgi-bin/.htaccess", "$param/htaccess.02.d", '3', "/dev/null");

#&easymod ("/home/httpd/cgi-bin/.htaccess", "$param/htaccess2.02.d", '3', "/dev/null");	### keep fix for blue interface

&easymod ("/var/smoothwall/main/ui/alertboxes.en.pl", "$param/alertboxes.en.pl.02.d", '2', "/dev/null");

&easymod ("/var/smoothwall/header.pl", "$param/header.pl.02.d", '1', "/dev/null");

&easymod ("/var/smoothwall/langs/base.pl", "$param/base.pl.02.d", '17', "/dev/null");
##&easymod21 ("/var/smoothwall/langs/base.pl", "$param/base.pl.02.d", '17', "/dev/null");

&easymod ("/etc/ld.so.conf", "$param/ld.so.conf.02.d", '1', "/dev/null");
system ('/sbin/ldconfig');

#&easymod ("/etc/rc.d/rc.firewall.up", "$param/rc.firewall.up3.02.d", '6', "/dev/null");	### keep for blue interface

#&easymod ("/etc/rc.d/rc.firewall.up", "$param/rc.firewall.up.02.d", '14', "/dev/null");	### keep fix for blue interface

#&easymod ("/etc/rc.d/rc.firewall.up", "$param/rc.firewall.up2.02.d", '10', "/dev/null");	### keep tweak for blue interface

&easymod ("/etc/rc.d/rc.netaddress.up", "$param/rc.netaddress.up.02.d", '1', "/dev/null");

&easymod ("/etc/rc.d/rc.netaddress.up", "$param/rc.netaddress.up2.02.d", '1', "/dev/null");

&easymod ("/etc/rc.d/rc.network", "$param/rc.network.02.d", '9', "/dev/null");

&easymod ("/etc/rc.d/rc.sysinit", "$param/rc.sysinit.02.d", '2', "/dev/null");

# # # # # # # # # # # #
# handle file linking #
# # # # # # # # # # # #

$dir = '/home/httpd/html/ui/assets/3.6/img/pagetitles';
#&uninstall ('page-nowireap.png', $dir);
&uninstall ('page-wireless.png', $dir);

$dir = "/var/smoothwall/mods/nowireap";
#&uninstall ("enable", $dir);
&uninstall ("installed", $dir);

print "\nDone\n\n";

# # # #
# end #
# # # #


sub easymod21
{
	my $targetfile = $_[0];
	my $searchfile = $_[1];
	my $linestodelete = $_[2];
	my $replacefile = $_[3];

	open(TARGET, "$targetfile") or die 'Unable to open target file.';
	my @target = <TARGET>;
	close(TARGET);

	open(SEARCH, "$searchfile") or die 'Unable to open search file';
	my @search = <SEARCH>;
	close(SEARCH);

	open(REPLACE, "$replacefile") or die 'Unable to open replace file.';
	my @replace = <REPLACE>;
	close(REPLACE);

	open(TEMP, ">/tmp/temp") or die 'Unable to open temporary file.';
	flock TEMP, 2;

	my $found = 0;
	my $line;
	foreach $line (@target)
	{
		if ($found == 0)
		{
			if ($line eq "@search")
			{
				$found = 1;
				if ($linestodelete > 0)
				{
					$linestodelete--;
				}
				else {print TEMP "$line"; }
				my $repline;
				foreach $repline (@replace) {print TEMP $repline; }
			}
			else {print TEMP "$line"; }
		}
		else
		{
			if ($linestodelete > 0)
			{
				$linestodelete--;
			}
			else {print TEMP "$line"; }
		}
	}	
	close(TEMP);
	system "/bin/cp /tmp/temp $targetfile";
	system "/bin/rm -f /tmp/temp";
}


